package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import java.util.Date;

import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class HargaNettoDiscPasienPulang
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "HargaNettoDiscPasienPulang_M")
public class HargaNettoDiscPasienPulang extends BaseMaster {
	@Column(name = "HargaDiscount", nullable = true)
	@Caption(value = "Harga Discount")
	private Double hargaDiscount;

	public void setHargaDiscount(Double hargaDiscount) {
		this.hargaDiscount = hargaDiscount;
	}

	public Double getHargaDiscount() {
		return this.hargaDiscount;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectKomponenHargaFk")
	@NotNull(message = "Kd Komponen Harga tidak boleh kosong")

	@Caption(value = "Object Komponen Harga")
	private KomponenHarga komponenHarga;

	public void setKomponenHarga(KomponenHarga komponenHarga) {
		this.komponenHarga = komponenHarga;
	}

	public KomponenHarga getKomponenHarga() {
		return this.komponenHarga;
	}

	@Column(name = "ObjectKomponenHargaFk", insertable = false, updatable = false)
	private Integer komponenHargaId;

	@ManyToOne
	@JoinColumn(name = "ObjectProdukFk")
	@NotNull(message = "Kd Produk tidak boleh kosong")

	@Caption(value = "Object Produk")
	private Produk produk;

	public void setProduk(Produk produk) {
		this.produk = produk;
	}

	public Produk getProduk() {
		return this.produk;
	}

	@Column(name = "ObjectProdukFk", insertable = false, updatable = false, nullable = false)
	private Integer produkId;

	@ManyToOne
	@JoinColumn(name = "ObjectRangeFk")
	@NotNull(message = "Kd Range tidak boleh kosong")

	@Caption(value = "Object Range")
	private Range range;

	public void setRange(Range range) {
		this.range = range;
	}

	public Range getRange() {
		return this.range;
	}

	@Column(name = "ObjectRangeFk", insertable = false, updatable = false, nullable = false)
	private Integer rangeId;

	@NotNull(message = "Persen Discount tidak boleh kosong")
	@Column(name = "PersenDiscount", nullable = false)
	@Caption(value = "Persen Discount")
	private Double persenDiscount;

	public void setPersenDiscount(Double persenDiscount) {
		this.persenDiscount = persenDiscount;
	}

	public Double getPersenDiscount() {
		return this.persenDiscount;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true)
	@Caption(value = "Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	public Date getTglBerlakuAkhir() {
		return this.tglBerlakuAkhir;
	}

	@NotNull(message = "Tgl Berlaku Awal tidak boleh kosong")
	@Column(name = "TglBerlakuAwal", nullable = false)
	@Caption(value = "Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	public Date getTglBerlakuAwal() {
		return this.tglBerlakuAwal;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.harganettodiscpasienpulang_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.harganettodiscpasienpulang_m_id_seq", sequenceName = "public.harganettodiscpasienpulang_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}